gi-gtk4-4.0.12: Gtk 4.x bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.PopoverBin

Contents

- Exported types
- Methods
  - getChild
  - getHandleInput
  - getMenuModel
  - getPopover
  - new
  - popdown
  - popup
  - setChild
  - setHandleInput
  - setMenuModel
  - setPopover
- Properties
  - child
  - handleInput
  - menuModel
  - popover

Description

A single child container with a popover.

You should use `GtkPopoverBin` whenever you need to present a `Popover` to the user.

## Actions

`GtkPopoverBin` defines the `menu.popup` action, which can be activated to present the popover to the user.

## CSS nodes

`GtkPopoverBin` has a single CSS node with the name `popoverbin`.

Since: 4.22

Synopsis

- newtype PopoverBin = PopoverBin (ManagedPtr PopoverBin)
- class (GObject o, IsDescendantOf PopoverBin o) => IsPopoverBin o
- toPopoverBin :: (MonadIO m, IsPopoverBin o) => o -> m PopoverBin
- popoverBinGetChild :: (HasCallStack, MonadIO m, IsPopoverBin a) => a -> m (Maybe Widget)
- popoverBinGetHandleInput :: (HasCallStack, MonadIO m, IsPopoverBin a) => a -> m Bool
- popoverBinGetMenuModel :: (HasCallStack, MonadIO m, IsPopoverBin a) => a -> m (Maybe MenuModel)
- popoverBinGetPopover :: (HasCallStack, MonadIO m, IsPopoverBin a) => a -> m (Maybe Popover)
- popoverBinNew :: (HasCallStack, MonadIO m) => m PopoverBin
- popoverBinPopdown :: (HasCallStack, MonadIO m, IsPopoverBin a) => a -> m ()
- popoverBinPopup :: (HasCallStack, MonadIO m, IsPopoverBin a) => a -> m ()
- popoverBinSetChild :: (HasCallStack, MonadIO m, IsPopoverBin a, IsWidget b) => a -> Maybe b -> m ()
- popoverBinSetHandleInput :: (HasCallStack, MonadIO m, IsPopoverBin a) => a -> Bool -> m ()
- popoverBinSetMenuModel :: (HasCallStack, MonadIO m, IsPopoverBin a, IsMenuModel b) => a -> Maybe b -> m ()
- popoverBinSetPopover :: (HasCallStack, MonadIO m, IsPopoverBin a, IsPopover b) => a -> Maybe b -> m ()
- clearPopoverBinChild :: (MonadIO m, IsPopoverBin o) => o -> m ()
- constructPopoverBinChild :: (IsPopoverBin o, MonadIO m, IsWidget a) => a -> m (GValueConstruct o)
- getPopoverBinChild :: (MonadIO m, IsPopoverBin o) => o -> m (Maybe Widget)
- setPopoverBinChild :: (MonadIO m, IsPopoverBin o, IsWidget a) => o -> a -> m ()
- constructPopoverBinHandleInput :: (IsPopoverBin o, MonadIO m) => Bool -> m (GValueConstruct o)
- getPopoverBinHandleInput :: (MonadIO m, IsPopoverBin o) => o -> m Bool
- setPopoverBinHandleInput :: (MonadIO m, IsPopoverBin o) => o -> Bool -> m ()
- clearPopoverBinMenuModel :: (MonadIO m, IsPopoverBin o) => o -> m ()
- constructPopoverBinMenuModel :: (IsPopoverBin o, MonadIO m, IsMenuModel a) => a -> m (GValueConstruct o)
- getPopoverBinMenuModel :: (MonadIO m, IsPopoverBin o) => o -> m (Maybe MenuModel)
- setPopoverBinMenuModel :: (MonadIO m, IsPopoverBin o, IsMenuModel a) => o -> a -> m ()
- clearPopoverBinPopover :: (MonadIO m, IsPopoverBin o) => o -> m ()
- constructPopoverBinPopover :: (IsPopoverBin o, MonadIO m, IsPopover a) => a -> m (GValueConstruct o)
- getPopoverBinPopover :: (MonadIO m, IsPopoverBin o) => o -> m (Maybe Popover)
- setPopoverBinPopover :: (MonadIO m, IsPopoverBin o, IsPopover a) => o -> a -> m ()

# Exported types

newtype PopoverBin Source #

Memory-managed wrapper type.

Constructors

PopoverBin (ManagedPtr PopoverBin) |

#### Instances

Instances details

Eq PopoverBin Source # |
Instance details Defined in GI.Gtk.Objects.PopoverBin Methods (==) :: PopoverBin -> PopoverBin -> Bool Source # (/=) :: PopoverBin -> PopoverBin -> Bool Source #
GObject PopoverBin Source # |
Instance details Defined in GI.Gtk.Objects.PopoverBin
ManagedPtrNewtype PopoverBin Source # |
Instance details Defined in GI.Gtk.Objects.PopoverBin Methods toManagedPtr :: PopoverBin -> ManagedPtr PopoverBin Source #
TypedObject PopoverBin Source # |
Instance details Defined in GI.Gtk.Objects.PopoverBin Methods glibType :: IO GType Source #
HasParentTypes PopoverBin Source # |
Instance details Defined in GI.Gtk.Objects.PopoverBin
IsGValue (Maybe PopoverBin) Source # | Convert `PopoverBin` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.PopoverBin Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe PopoverBin -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe PopoverBin) Source #
type ParentTypes PopoverBin Source # |
Instance details Defined in GI.Gtk.Objects.PopoverBin type ParentTypes PopoverBin = '[Widget, Object, Accessible, Buildable, ConstraintTarget]

class (GObject o, IsDescendantOf PopoverBin o) => IsPopoverBin o Source #

Type class for types which can be safely cast to `PopoverBin`, for instance with `toPopoverBin`.

#### Instances

Instances details

(GObject o, IsDescendantOf PopoverBin o) => IsPopoverBin o Source # |
Instance details Defined in GI.Gtk.Objects.PopoverBin

toPopoverBin :: (MonadIO m, IsPopoverBin o) => o -> m PopoverBin Source #

Cast to `PopoverBin`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

actionSetEnabled, activate, activateAction, activateDefault, addController, addCssClass, addMnemonicLabel, addTickCallback, allocate, announce, bindProperty, bindPropertyFull, childFocus, computeBounds, computeExpand, computePoint, computeTransform, contains, createPangoContext, createPangoLayout, disposeTemplate, dragCheckThreshold, errorBell, forceFloating, freezeNotify, getv, grabFocus, hasCssClass, hasDefault, hasFocus, hasVisibleFocus, hide, inDestruction, initTemplate, insertActionGroup, insertAfter, insertBefore, isAncestor, isDrawable, isFloating, isFocus, isSensitive, isVisible, keynavFailed, listMnemonicLabels, map, measure, mnemonicActivate, notify, notifyByPspec, observeChildren, observeControllers, pick, popdown, popup, queueAllocate, queueDraw, queueResize, realize, ref, refSink, removeController, removeCssClass, removeMnemonicLabel, removeTickCallback, resetProperty, resetRelation, resetState, runDispose, shouldLayout, show, sizeAllocate, snapshotChild, stealData, stealQdata, thawNotify, translateCoordinates, triggerTooltipQuery, unmap, unparent, unrealize, unref, unsetStateFlags, updateNextAccessibleSibling, updatePlatformState, updateProperty, updateRelation, updateState, watchClosure.

#### Getters

getAccessibleId, getAccessibleParent, getAccessibleRole, getAllocatedBaseline, getAllocatedHeight, getAllocatedWidth, getAllocation, getAncestor, getAtContext, getBaseline, getBounds, getBuildableId, getCanFocus, getCanTarget, getChild, getChildVisible, getClipboard, getColor, getCssClasses, getCssName, getCursor, getData, getDirection, getDisplay, getFirstAccessibleChild, getFirstChild, getFocusChild, getFocusOnClick, getFocusable, getFontMap, getFontOptions, getFrameClock, getHalign, getHandleInput, getHasTooltip, getHeight, getHexpand, getHexpandSet, getLastChild, getLayoutManager, getLimitEvents, getMapped, getMarginBottom, getMarginEnd, getMarginStart, getMarginTop, getMenuModel, getName, getNative, getNextAccessibleSibling, getNextSibling, getOpacity, getOverflow, getPangoContext, getParent, getPlatformState, getPopover, getPreferredSize, getPrevSibling, getPrimaryClipboard, getProperty, getQdata, getRealized, getReceivesDefault, getRequestMode, getRoot, getScaleFactor, getSensitive, getSettings, getSize, getSizeRequest, getStateFlags, getStyleContext, getTemplateChild, getTooltipMarkup, getTooltipText, getValign, getVexpand, getVexpandSet, getVisible, getWidth.

#### Setters

setAccessibleParent, setCanFocus, setCanTarget, setChild, setChildVisible, setCssClasses, setCursor, setCursorFromName, setData, setDataFull, setDirection, setFocusChild, setFocusOnClick, setFocusable, setFontMap, setFontOptions, setHalign, setHandleInput, setHasTooltip, setHexpand, setHexpandSet, setLayoutManager, setLimitEvents, setMarginBottom, setMarginEnd, setMarginStart, setMarginTop, setMenuModel, setName, setOpacity, setOverflow, setParent, setPopover, setProperty, setReceivesDefault, setSensitive, setSizeRequest, setStateFlags, setTooltipMarkup, setTooltipText, setValign, setVexpand, setVexpandSet, setVisible.

## getChild

popoverBinGetChild Source #

Arguments

:: (HasCallStack, MonadIO m, IsPopoverBin a) |
=> a | `self`: a popover bin
-> m (Maybe Widget) | Returns: the child widget

Retrieves the child widget of the popover bin.

Since: 4.22

## getHandleInput

popoverBinGetHandleInput :: (HasCallStack, MonadIO m, IsPopoverBin a) => a -> m Bool Source #

No description available in the introspection data.

## getMenuModel

popoverBinGetMenuModel Source #

Arguments

:: (HasCallStack, MonadIO m, IsPopoverBin a) |
=> a | `self`: a popover bin
-> m (Maybe MenuModel) | Returns: the menu model for the popover

Retrieves the menu model set using `popoverBinSetMenuModel`.

Since: 4.22

## getPopover

popoverBinGetPopover Source #

Arguments

:: (HasCallStack, MonadIO m, IsPopoverBin a) |
=> a | `self`: a popover bin
-> m (Maybe Popover) | Returns: a popover widget

Retrieves the `GtkPopover` set using `popoverBinSetPopover`.

Since: 4.22

## new

popoverBinNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m PopoverBin | Returns: the newly created popover bin

Creates a new popover bin widget.

Since: 4.22

## popdown

popoverBinPopdown Source #

Arguments

:: (HasCallStack, MonadIO m, IsPopoverBin a) |
=> a | `self`: a popover bin
-> m () |

Hides the popover from the user.

See: `popoverBinPopup`

Since: 4.22

## popup

popoverBinPopup Source #

Arguments

:: (HasCallStack, MonadIO m, IsPopoverBin a) |
=> a | `self`: a popover bin
-> m () |

Presents the popover to the user.

Use `popoverBinSetPopover` or `popoverBinSetMenuModel` to define the popover.

See: `popoverBinPopdown`

Since: 4.22

## setChild

popoverBinSetChild Source #

Arguments

:: (HasCallStack, MonadIO m, IsPopoverBin a, IsWidget b) |
=> a | `self`: a popover bin
-> Maybe b | `child`: the child of the popover bin
-> m () |

Sets the child of the popover bin.

Since: 4.22

## setHandleInput

popoverBinSetHandleInput Source #

Arguments

:: (HasCallStack, MonadIO m, IsPopoverBin a) |
=> a | `self`: a popover bin
-> Bool | `handleInput`: whether to handle input
-> m () |

Enables or disables input handling.

If enabled, the popover bin will pop up the popover on right-click or long press, as expected for a context menu.

Since: 4.22

## setMenuModel

popoverBinSetMenuModel Source #

Arguments

:: (HasCallStack, MonadIO m, IsPopoverBin a, IsMenuModel b) |
=> a | `self`: a popover bin
-> Maybe b | `model`: a menu model
-> m () |

Sets the menu model used to create the popover that will be presented when calling `popoverBinPopup`.

If `model` is `NULL`, the popover will be unset.

A `Popover` will be created from the menu model with `popoverMenuNewFromModel`. Actions will be connected as documented for this function.

If PopoverBin:popover is already set, it will be dissociated from the popover bin, and the property is set to `NULL`.

See: `popoverBinSetPopover`

Since: 4.22

## setPopover

popoverBinSetPopover Source #

Arguments

:: (HasCallStack, MonadIO m, IsPopoverBin a, IsPopover b) |
=> a | `self`: a popover bin
-> Maybe b | `popover`: a `GtkPopover`
-> m () |

Sets the `GtkPopover` that will be presented when calling `popoverBinPopup`.

If `popover` is `NULL`, the popover will be unset.

If PopoverBin:menuModel is set before calling this function, then the menu model property will be unset.

See: `popoverBinSetMenuModel`

Since: 4.22

# Properties

## child

The child widget of the popover bin.

Since: 4.22

clearPopoverBinChild :: (MonadIO m, IsPopoverBin o) => o -> m () Source #

Set the value of the “`child`” property to `Nothing`. When overloading is enabled, this is equivalent to

    clear #child

constructPopoverBinChild :: (IsPopoverBin o, MonadIO m, IsWidget a) => a -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`child`” property. This is rarely needed directly, but it is used by `new`.

getPopoverBinChild :: (MonadIO m, IsPopoverBin o) => o -> m (Maybe Widget) Source #

Get the value of the “`child`” property. When overloading is enabled, this is equivalent to

    get popoverBin #child

setPopoverBinChild :: (MonadIO m, IsPopoverBin o, IsWidget a) => o -> a -> m () Source #

Set the value of the “`child`” property. When overloading is enabled, this is equivalent to

    set popoverBin [ #child := value ]

## handleInput

Whether the popover bin will handle input to trigger the popup.

Since: 4.22

constructPopoverBinHandleInput :: (IsPopoverBin o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`handle-input`” property. This is rarely needed directly, but it is used by `new`.

getPopoverBinHandleInput :: (MonadIO m, IsPopoverBin o) => o -> m Bool Source #

Get the value of the “`handle-input`” property. When overloading is enabled, this is equivalent to

    get popoverBin #handleInput

setPopoverBinHandleInput :: (MonadIO m, IsPopoverBin o) => o -> Bool -> m () Source #

Set the value of the “`handle-input`” property. When overloading is enabled, this is equivalent to

    set popoverBin [ #handleInput := value ]

## menuModel

The `GMenuModel` from which the popup will be created.

See `popoverBinSetMenuModel` for the interaction with the PopoverBin:popover property.

Since: 4.22

clearPopoverBinMenuModel :: (MonadIO m, IsPopoverBin o) => o -> m () Source #

Set the value of the “`menu-model`” property to `Nothing`. When overloading is enabled, this is equivalent to

    clear #menuModel

constructPopoverBinMenuModel :: (IsPopoverBin o, MonadIO m, IsMenuModel a) => a -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`menu-model`” property. This is rarely needed directly, but it is used by `new`.

getPopoverBinMenuModel :: (MonadIO m, IsPopoverBin o) => o -> m (Maybe MenuModel) Source #

Get the value of the “`menu-model`” property. When overloading is enabled, this is equivalent to

    get popoverBin #menuModel

setPopoverBinMenuModel :: (MonadIO m, IsPopoverBin o, IsMenuModel a) => o -> a -> m () Source #

Set the value of the “`menu-model`” property. When overloading is enabled, this is equivalent to

    set popoverBin [ #menuModel := value ]

## popover

The `GtkPopover` that will be popped up when calling `popoverBinPopup`.

Since: 4.22

clearPopoverBinPopover :: (MonadIO m, IsPopoverBin o) => o -> m () Source #

Set the value of the “`popover`” property to `Nothing`. When overloading is enabled, this is equivalent to

    clear #popover

constructPopoverBinPopover :: (IsPopoverBin o, MonadIO m, IsPopover a) => a -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`popover`” property. This is rarely needed directly, but it is used by `new`.

getPopoverBinPopover :: (MonadIO m, IsPopoverBin o) => o -> m (Maybe Popover) Source #

Get the value of the “`popover`” property. When overloading is enabled, this is equivalent to

    get popoverBin #popover

setPopoverBinPopover :: (MonadIO m, IsPopoverBin o, IsPopover a) => o -> a -> m () Source #

Set the value of the “`popover`” property. When overloading is enabled, this is equivalent to

    set popoverBin [ #popover := value ]